package se.chalmers.cs.gf.dot;

import java_cup.runtime.*;
import se.chalmers.cs.gf.dot.Absyn.Graph;
import java.io.*;

public class ParseDot {

        public static Graph parseGraph(Reader in) {
                Yylex l = new Yylex(in);
                parser p =  new parser(l);

                try {
                        Graph parse_tree = p.pGraph();
                        return parse_tree;
                } catch(Throwable e) {
                        System.err.println("Error parsing graph: "
                                           + e.toString() + " at line "
                                           + l.line_num()
                                           + ", near \"" + l.buff()
                                           + "\" :");
                        return null;
                }
        }

        public static Graph parseGraph(String str) {
                return parseGraph(new StringReader(str));
        }

}
