package se.chalmers.cs.gf.tramdemo;

import se.chalmers.cs.gf.tramdemo.query.*;

import se.chalmers.cs.gf.util.Pair;
import static se.chalmers.cs.gf.util.Pair.pair;

import java.awt.Point;
import java.util.*;

public class InterpretQuery {

        private FindPlace placeFinder;

        public InterpretQuery(CoordMap<String> coordMap, String here) {
                this.placeFinder = new FindPlace(coordMap, here);
        }

        public List<Pair<String,ShortestPathQuery>> interpretQueries(Collection<Pair<String,Query>> qs) {
                List<Pair<String,ShortestPathQuery>> rs 
                        = new LinkedList<Pair<String,ShortestPathQuery>>();
                for (Pair<String,Query> p : qs)
                        for (ShortestPathQuery q : interpretQuery(p.snd))
                                rs.add(pair(p.fst,q));
                return rs;
        }

        public List<ShortestPathQuery> interpretQuery(Query q) {
                Input i = ((QInput)q).input_; // FIXME: do with visitor
                return i.accept(new InputInterpreter(), null);
        }

        private class InputInterpreter implements Input.Visitor<List<ShortestPathQuery>, Object> {

                private List<ShortestPathQuery> resolveFromTo(Place from, Place to) {
                        List<String> froms = placeFinder.findPlace(from);
                        List<String> tos = placeFinder.findPlace(to);
                        List<ShortestPathQuery> qs = new LinkedList<ShortestPathQuery>();
                        for (String f : froms)
                                for (String t : tos)
                                        qs.add(new ShortestPathQuery(f, t));
                        return qs;
                }

                public List<ShortestPathQuery> visit(GoToFrom p, Object arg) {
                        return resolveFromTo(p.place_1, p.place_0);
                }

                public List<ShortestPathQuery> visit(ComeFrom p, Object arg) {
                        return resolveFromTo(p.place_, new PHere());
                }

                public List<ShortestPathQuery> visit(GoFromTo p, Object arg) {
                        return resolveFromTo(p.place_0, p.place_1);
                }

                public List<ShortestPathQuery> visit(GoTo p, Object arg) {
                       return resolveFromTo(new PHere(), p.place_);
                }
        }

}
