package se.chalmers.cs.gf.tramdemo;

import java.awt.Point;
import java.util.Collection;
import java.util.Collections;
import java.util.EventObject;

public class MapClickEvent extends EventObject {

        private Point point;

        private Collection<String> regions;

        private long time;

        public MapClickEvent(Object source, Point point, Collection<String> regions, long time) {
                super(source);
                this.point = point;
                this.regions = Collections.unmodifiableCollection(regions);
                this.time = time;
        }

        public MapClickEvent(Object source, Point point, long time) {
                this(source, point, Collections.<String>emptyList(), time);
        }

        /**
         *  Gets the map coordinates of the click.
         */
        public Point getPoint() {
                return point;
        }

        public Collection<String> getRegions() {
                return regions;
        }

        /**
         *  Get the time (in milliseconds since the Unix epoch)
         *  at which the click happend.
         */
        public long getTime() {
                return time;
        }

        public String toString() {
                return "MapClick{(" + point.x + "," + point.y + ")," + regions + "}";
        }

}
