package se.chalmers.cs.gf.tramdemo;

import se.gu.ling.trindikit.oaa.common.*;

import com.sri.oaa2.icl.*;

import se.chalmers.cs.gf.dialogutil.IclUtil;

import java.util.List;

/**
 *  Declares a solvable clicks(Clicks) which gets all the clicks
 *  which have occured since the last call.
 *
 *  Example solution:
 *  clicks([click(['Valand']),click([]),click(['Chalmers','Vasaplatsen'])])
 */
public class MapClickSolver extends OAASolver {

        // FIXME: add parameters for click time to live etc.
        private static String solvableString = "clicks(Clicks)";
        
        private TramMap map;

        private MapClickEventCollector clicks;

        public MapClickSolver(TramMap map) {
                super(solvableString);
                this.map = map;
                this.clicks = new MapClickEventCollector();
                map.addMapClickListener(clicks);
        }

        public boolean solve(IclTerm goal, IclList params, IclList answers) {
                if (!goal.getTerm(0).isVar())
                        return false;
                
                List<MapClickEvent> cs = clicks.getAndClearClicks();
                IclList l = new IclList();
                for (MapClickEvent e : cs)
                        l.add(clickToTerm(e));

                IclTerm ans = new IclStruct("clicks", l);
                answers.add(ans);

                return true;
        }

        private IclTerm clickToTerm(MapClickEvent e) {
                IclList regions = new IclList();
                for (String region : e.getRegions())
                        regions.add(new IclStr(region));
                return new IclStruct("click", regions);
        }
        
}
