package se.chalmers.cs.gf.tramdemo;

import java.awt.Point;
import java.util.*;
import java.io.*;

import se.chalmers.cs.gf.util.FileUtil;

import se.chalmers.cs.gf.graph.*;

public class TransportNetwork extends Graph<TransportNetwork.StopData,String> {

        public TransportNetwork() {}

        public CoordMap<String> getCoordMap(double clickThreshold) {
                CoordMap<String> coordMap 
                        = new CoordMap<String>(clickThreshold);
                for (Node n : nodes()) {
                        Point p = n.getValue().getPos();
                        coordMap.add(p.x, p.y, n.getKey());
                }
                return coordMap;
        }

        public static class StopData {
                private Point pos;
                private String name;
                public StopData(Point pos, String name) {
                        this.pos = pos;
                        this.name = name;
                }
                /**
                 *  Get the position of this stop.
                 */
                public Point getPos() { return pos; }
                /** 
                 *  Get the human readable name for this stop.
                 */
                public String getName() { return name; }
        }

}
